Index: drivers/filesystems/btrfs/search.c
===================================================================
--- drivers/filesystems/btrfs/search.c	(révision 74430)
+++ drivers/filesystems/btrfs/search.c	(copie de travail)
@@ -551,129 +204,418 @@
         return;
     }
     
-    Status = dev_ioctl(devobj, IOCTL_STORAGE_GET_DEVICE_NUMBER, NULL, 0,
-                       &sdn, sizeof(STORAGE_DEVICE_NUMBER), TRUE, &iosb);
-    if (!NT_SUCCESS(Status)) {
-        ERR("IOCTL_STORAGE_GET_DEVICE_NUMBER returned %08x\n", Status);
-        goto end;
-    }
-    
-    ExAcquireResourceExclusiveLite(&volumes_lock, TRUE);
-    add_pnp_disk(sdn.DeviceNumber, devpath);
-    ExReleaseResourceLite(&volumes_lock);
-    
     dlisize = 0;
     
     do {
         dlisize += 1024;
+        
+        if (dli)
+            ExFreePool(dli);
+        
         dli = ExAllocatePoolWithTag(PagedPool, dlisize, ALLOC_TAG);
+        if (!dli) {
+            ERR("out of memory\n");
+            goto end;
+        }
     
         Status = dev_ioctl(devobj, IOCTL_DISK_GET_DRIVE_LAYOUT_EX, NULL, 0,
                            dli, dlisize, TRUE, &iosb);
     } while (Status == STATUS_BUFFER_TOO_SMALL);
     
-    if (!NT_SUCCESS(Status)) {
+    // only consider disk as a potential filesystem if it has no partitions
+    if (NT_SUCCESS(Status) && dli->PartitionCount > 0) {
         ExFreePool(dli);
-        goto no_parts;
+        goto end;
     }
     
-    wcscpy(devnamew, device_harddisk);
-    devname.Buffer = devnamew;
-    devname.MaximumLength = sizeof(devnamew);
-    devname.Length = wcslen(device_harddisk) * sizeof(WCHAR);
+    ExFreePool(dli);
+    
+    Status = dev_ioctl(devobj, IOCTL_DISK_GET_LENGTH_INFO, NULL, 0,
+                        &gli, sizeof(gli), TRUE, NULL);
+    
+    if (!NT_SUCCESS(Status)) {
+        ERR("error reading length information: %08x\n", Status);
+        goto end;
+    }
 
-    num.Buffer = numw;
-    num.MaximumLength = sizeof(numw);
-    RtlIntegerToUnicodeString(sdn.DeviceNumber, 10, &num);
-    RtlAppendUnicodeStringToString(&devname, &num);
+    Status = dev_ioctl(devobj, IOCTL_STORAGE_GET_DEVICE_NUMBER, NULL, 0,
+                       &sdn, sizeof(STORAGE_DEVICE_NUMBER), TRUE, NULL);
+    if (!NT_SUCCESS(Status)) {
+        TRACE("IOCTL_STORAGE_GET_DEVICE_NUMBER returned %08x\n", Status);
+        sdn.DeviceNumber = 0xffffffff;
+        sdn.PartitionNumber = 0;
+    } else
+        TRACE("DeviceType = %u, DeviceNumber = %u, PartitionNumber = %u\n", sdn.DeviceType, sdn.DeviceNumber, sdn.PartitionNumber);
+
+    test_vol(mountmgr, devobj, devpath, sdn.DeviceNumber, sdn.PartitionNumber, devpath, gli.Length.QuadPart);
     
-    bspus.Buffer = bs_partition;
-    bspus.Length = bspus.MaximumLength = wcslen(bs_partition) * sizeof(WCHAR);
-    RtlAppendUnicodeStringToString(&devname, &bspus);
+end:
+    ObDereferenceObject(FileObject);
+    ObDereferenceObject(mountmgrfo);
+}
+
+void remove_volume_child(volume_device_extension* vde, volume_child* vc, BOOL no_release_lock) {
+    NTSTATUS Status;
     
-    preflen = devname.Length;
+    if (vc->notification_entry)
+#ifndef __REACTOS__
+        IoUnregisterPlugPlayNotificationEx(vc->notification_entry);
+#else
+        IoUnregisterPlugPlayNotification(vc->notification_entry);
+#endif
     
-    for (i = 0; i < dli->PartitionCount; i++) {
-        if (dli->PartitionEntry[i].PartitionLength.QuadPart != 0 && dli->PartitionEntry[i].PartitionNumber != 0) {
-            devname.Length = preflen;
-            RtlIntegerToUnicodeString(dli->PartitionEntry[i].PartitionNumber, 10, &num);
-            RtlAppendUnicodeStringToString(&devname, &num);
+    ObDereferenceObject(vc->devobj);
+    ExFreePool(vc->pnp_name.Buffer);
+    RemoveEntryList(&vc->list_entry);
+    ExFreePool(vc);
+    
+    vde->children_loaded--;
+    
+    if (vde->mounted_device) {
+//         device_extension* Vcb = vde->mounted_device->DeviceExtension;
+// 
+        // FIXME - hangs
+//         Status = FsRtlNotifyVolumeEvent(Vcb->root_file, FSRTL_VOLUME_DISMOUNT);
+//         if (!NT_SUCCESS(Status))
+//             WARN("FsRtlNotifyVolumeEvent returned %08x\n", Status);
+        
+        Status = pnp_surprise_removal(vde->mounted_device, NULL);
+        if (!NT_SUCCESS(Status))
+            ERR("pnp_surprise_removal returned %08x\n", Status);
+    }
+    
+    Status = IoSetDeviceInterfaceState(&vde->bus_name, FALSE);
+    if (!NT_SUCCESS(Status))
+        WARN("IoSetDeviceInterfaceState returned %08x\n", Status);
+    
+    if (vde->children_loaded > 0) {
+        UNICODE_STRING mmdevpath;
+        PFILE_OBJECT FileObject;
+        PDEVICE_OBJECT mountmgr;
+        LIST_ENTRY* le;
+        
+        RtlInitUnicodeString(&mmdevpath, MOUNTMGR_DEVICE_NAME);
+        Status = IoGetDeviceObjectPointer(&mmdevpath, FILE_READ_ATTRIBUTES, &FileObject, &mountmgr);
+        if (!NT_SUCCESS(Status))
+            ERR("IoGetDeviceObjectPointer returned %08x\n", Status);
+        else {
+            le = vde->children.Flink;
             
-            test_vol(DriverObject, mountmgr, &devname, sdn.DeviceNumber, dli->PartitionEntry[i].PartitionNumber, &volumes);
+            while (le != &vde->children) {
+                volume_child* vc = CONTAINING_RECORD(le, volume_child, list_entry);
+                
+                if (vc->had_drive_letter) { // re-add entry to mountmgr
+                    MOUNTDEV_NAME mdn;
+                    
+                    Status = dev_ioctl(vc->devobj, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0, &mdn, sizeof(MOUNTDEV_NAME), TRUE, NULL);
+                    if (!NT_SUCCESS(Status) && Status != STATUS_BUFFER_OVERFLOW)
+                        ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned %08x\n", Status);
+                    else {
+                        MOUNTDEV_NAME* mdn2;
+                        ULONG mdnsize = offsetof(MOUNTDEV_NAME, Name[0]) + mdn.NameLength;
+                        
+                        mdn2 = ExAllocatePoolWithTag(PagedPool, mdnsize, ALLOC_TAG);
+                        if (!mdn2)
+                            ERR("out of memory\n");
+                        else {
+                            Status = dev_ioctl(vc->devobj, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0, mdn2, mdnsize, TRUE, NULL);
+                            if (!NT_SUCCESS(Status))
+                                ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned %08x\n", Status);
+                            else {
+                                UNICODE_STRING name;
+                                
+                                name.Buffer = mdn2->Name;
+                                name.Length = name.MaximumLength = mdn2->NameLength;
+                                
+                                Status = mountmgr_add_drive_letter(mountmgr, &name);
+                                if (!NT_SUCCESS(Status))
+                                    WARN("mountmgr_add_drive_letter returned %08x\n", Status);
+                            }
+                            
+                            ExFreePool(mdn2);
+                        }
+                    }
+                }
+                
+                le = le->Flink;
+            }
             
-            num_parts++;
+            ObDereferenceObject(FileObject);
         }
+        
+        if (vde->device->Characteristics & FILE_REMOVABLE_MEDIA) {
+            vde->device->Characteristics &= ~FILE_REMOVABLE_MEDIA;
+            
+            le = vde->children.Flink;
+            while (le != &vde->children) {
+                volume_child* vc = CONTAINING_RECORD(le, volume_child, list_entry);
+                
+                if (vc->devobj->Characteristics & FILE_REMOVABLE_MEDIA) {
+                    vde->device->Characteristics |= FILE_REMOVABLE_MEDIA;
+                    break;
+                }
+                
+                le = le->Flink;
+            }
+        }
     }
     
-    ExFreePool(dli);
+    if (vde->children_loaded == 0) { // remove volume device
+        UNICODE_STRING mmdevpath;
+        PDEVICE_OBJECT mountmgr;
+        PFILE_OBJECT mountmgrfo;
+        
+        ExReleaseResourceLite(&vde->child_lock);
+        RemoveEntryList(&vde->list_entry);
+        
+        RtlInitUnicodeString(&mmdevpath, MOUNTMGR_DEVICE_NAME);
+        Status = IoGetDeviceObjectPointer(&mmdevpath, FILE_READ_ATTRIBUTES, &mountmgrfo, &mountmgr);
+        if (!NT_SUCCESS(Status))
+            ERR("IoGetDeviceObjectPointer returned %08x\n", Status);
+        else {
+            remove_drive_letter(mountmgr, &vde->name);
+            
+            ObDereferenceObject(mountmgrfo);
+        }
+        
+        if (vde->name.Buffer)
+            ExFreePool(vde->name.Buffer);
+        
+        ExDeleteResourceLite(&vde->child_lock);
+        
+        IoSetDeviceInterfaceState(&vde->bus_name, FALSE);
+        
+        IoDetachDevice(vde->pdo);
+        
+        IoDeleteDevice(vde->device);
+    } else if (!no_release_lock)
+        ExReleaseResourceLite(&vde->child_lock);
+}
+
+void volume_arrival(PDRIVER_OBJECT DriverObject, PUNICODE_STRING devpath) {
+    STORAGE_DEVICE_NUMBER sdn;
+    PFILE_OBJECT FileObject, mountmgrfo;
+    UNICODE_STRING mmdevpath;
+    PDEVICE_OBJECT devobj, mountmgr;
+    GET_LENGTH_INFORMATION gli;
+    NTSTATUS Status;
     
-no_parts:
-    if (num_parts == 0) {
-        devname.Length = preflen;
-        devname.Buffer[devname.Length / sizeof(WCHAR)] = '0';
-        devname.Length += sizeof(WCHAR);
+    TRACE("%.*S\n", devpath->Length / sizeof(WCHAR), devpath->Buffer);
+    
+    Status = IoGetDeviceObjectPointer(devpath, FILE_READ_ATTRIBUTES, &FileObject, &devobj);
+    if (!NT_SUCCESS(Status)) {
+        ERR("IoGetDeviceObjectPointer returned %08x\n", Status);
+        return;
+    }
+    
+    // make sure we're not processing devices we've created ourselves
+    
+    if (devobj->DriverObject == DriverObject)
+        goto end;
+
+    Status = dev_ioctl(devobj, IOCTL_DISK_GET_LENGTH_INFO, NULL, 0, &gli, sizeof(gli), TRUE, NULL);
+    if (!NT_SUCCESS(Status)) {
+        ERR("IOCTL_DISK_GET_LENGTH_INFO returned %08x\n", Status);
+        goto end;
+    }
+    
+    Status = dev_ioctl(devobj, IOCTL_STORAGE_GET_DEVICE_NUMBER, NULL, 0,
+                       &sdn, sizeof(STORAGE_DEVICE_NUMBER), TRUE, NULL);
+    if (!NT_SUCCESS(Status)) {
+        TRACE("IOCTL_STORAGE_GET_DEVICE_NUMBER returned %08x\n", Status);
+        sdn.DeviceNumber = 0xffffffff;
+        sdn.PartitionNumber = 0;
+    } else
+        TRACE("DeviceType = %u, DeviceNumber = %u, PartitionNumber = %u\n", sdn.DeviceType, sdn.DeviceNumber, sdn.PartitionNumber);
+    
+    // If we've just added a partition to a whole-disk filesystem, unmount it
+    if (sdn.DeviceNumber != 0xffffffff) {
+        LIST_ENTRY* le;
         
-        test_vol(DriverObject, mountmgr, &devname, sdn.DeviceNumber, 0, &volumes);
+        ExAcquireResourceExclusiveLite(&volume_list_lock, TRUE);
+        
+        le = volume_list.Flink;
+        while (le != &volume_list) {
+            volume_device_extension* vde = CONTAINING_RECORD(le, volume_device_extension, list_entry);
+            LIST_ENTRY* le2;
+            BOOL changed = FALSE;
+            
+            ExAcquireResourceExclusiveLite(&vde->child_lock, TRUE);
+            
+            le2 = vde->children.Flink;
+            while (le2 != &vde->children) {
+                volume_child* vc = CONTAINING_RECORD(le2, volume_child, list_entry);
+                LIST_ENTRY* le3 = le2->Flink;
+                
+                if (vc->disk_num == sdn.DeviceNumber && vc->part_num == 0) {
+                    TRACE("removing device\n");
+                    
+                    remove_volume_child(vde, vc, FALSE);
+                    changed = TRUE;
+
+                    break;
+                }
+                
+                le2 = le3;
+            }
+            
+            if (!changed)
+                ExReleaseResourceLite(&vde->child_lock);
+            else
+                break;
+            
+            le = le->Flink;
+        }
+        
+        ExReleaseResourceLite(&volume_list_lock);
     }
     
+    RtlInitUnicodeString(&mmdevpath, MOUNTMGR_DEVICE_NAME);
+    Status = IoGetDeviceObjectPointer(&mmdevpath, FILE_READ_ATTRIBUTES, &mountmgrfo, &mountmgr);
+    if (!NT_SUCCESS(Status)) {
+        ERR("IoGetDeviceObjectPointer returned %08x\n", Status);
+        goto end;
+    }
+
+    test_vol(mountmgr, devobj, devpath, sdn.DeviceNumber, sdn.PartitionNumber, devpath, gli.Length.QuadPart);
+    
+    ObDereferenceObject(mountmgrfo);
+    
 end:
-    refresh_mountmgr(mountmgr, &volumes);
-
     ObDereferenceObject(FileObject);
-    ObDereferenceObject(FileObject2);
 }
 
-static void disk_removal(PDRIVER_OBJECT DriverObject, PUNICODE_STRING devpath) {
+void volume_removal(PDRIVER_OBJECT DriverObject, PUNICODE_STRING devpath) {
     LIST_ENTRY* le;
-    pnp_disk* disk = NULL;
+    UNICODE_STRING devpath2;
     
-    // FIXME - remove Partition0Btrfs devices and unlink from mountmgr
-    // FIXME - emergency unmount of RAIDed volumes
+    TRACE("%.*S\n", devpath->Length / sizeof(WCHAR), devpath->Buffer);
     
-    ExAcquireResourceExclusiveLite(&volumes_lock, TRUE);
+    UNUSED(DriverObject);
     
-    le = pnp_disks.Flink;
-    while (le != &pnp_disks) {
-        pnp_disk* disk2 = CONTAINING_RECORD(le, pnp_disk, list_entry);
+    devpath2 = *devpath;
+    
+    if (devpath->Length > 4 * sizeof(WCHAR) && devpath->Buffer[0] == '\\' && (devpath->Buffer[1] == '\\' || devpath->Buffer[1] == '?') &&
+        devpath->Buffer[2] == '?' && devpath->Buffer[3] == '\\') {
+        devpath2.Buffer = &devpath2.Buffer[3];
+        devpath2.Length -= 3 * sizeof(WCHAR);
+        devpath2.MaximumLength -= 3 * sizeof(WCHAR);
+    }
+    
+    ExAcquireResourceExclusiveLite(&volume_list_lock, TRUE);
+    
+    le = volume_list.Flink;
+    while (le != &volume_list) {
+        volume_device_extension* vde = CONTAINING_RECORD(le, volume_device_extension, list_entry);
+        LIST_ENTRY* le2;
+        BOOL changed = FALSE;
+
+        ExAcquireResourceExclusiveLite(&vde->child_lock, TRUE);
         
-        if (disk2->devpath.Length == devpath->Length &&
-            RtlCompareMemory(disk2->devpath.Buffer, devpath->Buffer, devpath->Length) == devpath->Length) {
-            disk = disk2;
-            break;
+        le2 = vde->children.Flink;
+        while (le2 != &vde->children) {
+            volume_child* vc = CONTAINING_RECORD(le2, volume_child, list_entry);
+            LIST_ENTRY* le3 = le2->Flink;
+            
+            if (vc->pnp_name.Length == devpath2.Length && RtlCompareMemory(vc->pnp_name.Buffer, devpath2.Buffer, devpath2.Length) == devpath2.Length) {
+                TRACE("removing device\n");
+                
+                remove_volume_child(vde, vc, FALSE);
+                changed = TRUE;
+                
+                break;
+            }
+            
+            le2 = le3;
         }
         
+        if (!changed)
+            ExReleaseResourceLite(&vde->child_lock);
+        else
+            break;
+        
         le = le->Flink;
     }
     
-    if (!disk) {
-        ExReleaseResourceLite(&volumes_lock);
+    ExReleaseResourceLite(&volume_list_lock);
+}
+
+typedef struct {
+    PDRIVER_OBJECT DriverObject;
+    UNICODE_STRING name;
+    pnp_callback func;
+    PIO_WORKITEM work_item;
+} pnp_callback_context;
+
+#ifdef __REACTOS__
+static void NTAPI do_pnp_callback(PDEVICE_OBJECT DeviceObject, PVOID con) {
+#else
+static void do_pnp_callback(PDEVICE_OBJECT DeviceObject, PVOID con) {
+#endif
+    pnp_callback_context* context = con;
+    
+    UNUSED(DeviceObject);
+    
+    context->func(context->DriverObject, &context->name);
+    
+    if (context->name.Buffer)
+        ExFreePool(context->name.Buffer);
+    
+    IoFreeWorkItem(context->work_item);
+}
+
+static void enqueue_pnp_callback(PDRIVER_OBJECT DriverObject, PUNICODE_STRING name, pnp_callback func) {
+    PIO_WORKITEM work_item;
+    pnp_callback_context* context;
+
+    work_item = IoAllocateWorkItem(devobj);
+        
+    context = ExAllocatePoolWithTag(PagedPool, sizeof(pnp_callback_context), ALLOC_TAG);
+    
+    if (!context) {
+        ERR("out of memory\n");
+        IoFreeWorkItem(work_item);
         return;
     }
-
-    le = volumes.Flink;
-    while (le != &volumes) {
-        volume* v = CONTAINING_RECORD(le, volume, list_entry);
-        LIST_ENTRY* le2 = le->Flink;
-        
-        if (v->disk_num == disk->disk_num) {
-            if (v->devpath.Buffer)
-                ExFreePool(v->devpath.Buffer);
-            
-            RemoveEntryList(&v->list_entry);
-            
-            ExFreePool(v);
+    
+    context->DriverObject = DriverObject;
+    
+    if (name->Length > 0) {
+        context->name.Buffer = ExAllocatePoolWithTag(PagedPool, name->Length, ALLOC_TAG);
+        if (!context->name.Buffer) {
+            ERR("out of memory\n");
+            ExFreePool(context);
+            IoFreeWorkItem(work_item);
+            return;
         }
         
-        le = le2;
+        RtlCopyMemory(context->name.Buffer, name->Buffer, name->Length);
+        context->name.Length = context->name.MaximumLength = name->Length;
+    } else {
+        context->name.Length = context->name.MaximumLength = 0;
+        context->name.Buffer = NULL;
     }
     
-    ExReleaseResourceLite(&volumes_lock);
+    context->func = func;
+    context->work_item = work_item;
     
-    ExFreePool(disk->devpath.Buffer);
+    IoQueueWorkItem(work_item, do_pnp_callback, DelayedWorkQueue, context);
+}
+
+#ifdef __REACTOS__
+NTSTATUS NTAPI volume_notification(PVOID NotificationStructure, PVOID Context) {
+#else
+NTSTATUS volume_notification(PVOID NotificationStructure, PVOID Context) {
+#endif
+    DEVICE_INTERFACE_CHANGE_NOTIFICATION* dicn = (DEVICE_INTERFACE_CHANGE_NOTIFICATION*)NotificationStructure;
+    PDRIVER_OBJECT DriverObject = (PDRIVER_OBJECT)Context;
     
-    RemoveEntryList(&disk->list_entry);
+    if (RtlCompareMemory(&dicn->Event, &GUID_DEVICE_INTERFACE_ARRIVAL, sizeof(GUID)) == sizeof(GUID))
+        enqueue_pnp_callback(DriverObject, dicn->SymbolicLinkName, volume_arrival);
+    else if (RtlCompareMemory(&dicn->Event, &GUID_DEVICE_INTERFACE_REMOVAL, sizeof(GUID)) == sizeof(GUID))
+        enqueue_pnp_callback(DriverObject, dicn->SymbolicLinkName, volume_removal);
     
-    ExFreePool(disk);
+    return STATUS_SUCCESS;
 }
 
 #ifdef __REACTOS__
@@ -685,9 +627,9 @@
     PDRIVER_OBJECT DriverObject = (PDRIVER_OBJECT)Context;
     
     if (RtlCompareMemory(&dicn->Event, &GUID_DEVICE_INTERFACE_ARRIVAL, sizeof(GUID)) == sizeof(GUID))
-        disk_arrival(DriverObject, dicn->SymbolicLinkName);
+        enqueue_pnp_callback(DriverObject, dicn->SymbolicLinkName, disk_arrival);
     else if (RtlCompareMemory(&dicn->Event, &GUID_DEVICE_INTERFACE_REMOVAL, sizeof(GUID)) == sizeof(GUID))
-        disk_removal(DriverObject, dicn->SymbolicLinkName);
+        enqueue_pnp_callback(DriverObject, dicn->SymbolicLinkName, volume_removal);
     
     return STATUS_SUCCESS;
 }
Index: drivers/filesystems/btrfs/security.c
===================================================================
--- drivers/filesystems/btrfs/security.c	(révision 74430)
+++ drivers/filesystems/btrfs/security.c	(copie de travail)
@@ -1,4 +1,4 @@
-/* Copyright (c) Mark Harmstone 2016
+/* Copyright (c) Mark Harmstone 2016-17
  * 
  * This file is part of WinBtrfs.
  * 
@@ -695,7 +695,7 @@
     ExFreePool(groupsid);
 }
 
-static NTSTATUS STDCALL get_file_security(device_extension* Vcb, PFILE_OBJECT FileObject, SECURITY_DESCRIPTOR* relsd, ULONG* buflen, SECURITY_INFORMATION flags) {
+static NTSTATUS STDCALL get_file_security(PFILE_OBJECT FileObject, SECURITY_DESCRIPTOR* relsd, ULONG* buflen, SECURITY_INFORMATION flags) {
     NTSTATUS Status;
     fcb* fcb = FileObject->FsContext;
     ccb* ccb = FileObject->FsContext2;
@@ -739,9 +739,12 @@
 
     top_level = is_top_level(Irp);
     
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
-        goto exit;
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_query_security(DeviceObject, Irp);
+        goto end;
+    } else if (!Vcb || Vcb->type != VCB_TYPE_FS) {
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
     }
     
     if (!ccb) {
@@ -786,7 +789,7 @@
     
     buflen = IrpSp->Parameters.QuerySecurity.Length;
     
-    Status = get_file_security(Vcb, IrpSp->FileObject, sd, &buflen, IrpSp->Parameters.QuerySecurity.SecurityInformation);
+    Status = get_file_security(IrpSp->FileObject, sd, &buflen, IrpSp->Parameters.QuerySecurity.SecurityInformation);
     
     if (NT_SUCCESS(Status))
         Irp->IoStatus.Information = IrpSp->Parameters.QuerySecurity.Length;
@@ -803,7 +806,6 @@
 
     IoCompleteRequest(Irp, IO_NO_INCREMENT);
     
-exit:
     if (top_level) 
         IoSetTopLevelIrp(NULL);    
     
@@ -910,9 +912,12 @@
 
     top_level = is_top_level(Irp);
     
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
-        goto exit;
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_set_security(DeviceObject, Irp);
+        goto end;
+    } else if (!Vcb || Vcb->type != VCB_TYPE_FS) {
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
     }
     
     if (!ccb) {
@@ -961,7 +966,6 @@
     
     TRACE("returning %08x\n", Status);
 
-exit:
     if (top_level) 
         IoSetTopLevelIrp(NULL);
 
